var FoxGo = {
  onLoad: function(window, event) {
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

    // Get console service for logging stuff
    this.console = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);

    // Grab our canvas and set it to the right size
    this.board = event.target.getElementById("foxgo-board");
    this.info = event.target.getElementById("foxgo-gameinfo");
    this.comments = event.target.getElementById("foxgo-comments");
    this.moveLabel = event.target.getElementById("foxgo-move-number");
    this.blackPrisoners = event.target.getElementById("foxgo-black-prisoners");
    this.whitePrisoners = event.target.getElementById("foxgo-white-prisoners");
    this.guessBar = event.target.getElementById("foxgo-guess-mode-bar");
    this.gameMenu = event.target.getElementById("foxgo-game-menu");

    // Now set up the main app logic components. 
    this.model = new BoardModel();
    this.view = new BoardView(this.model, this.board, this.moveLabel, this.blackPrisoners, this.whitePrisoners);
    this.infoView = new InfoView(this.model, this.info, this.gameMenu);
    this.commentView = new CommentView(this.model, this.comments);

    this.controller = new BoardController(this.model, this.view, this.infoView, this.commentView, this.guessBar);

    // Get access to mozilla preferences.

    this.prefs = new Prefs(event.target, this.controller);
    this.prefs.initializeMenu();

    this.controller.newGame();

    // initialization code
    this.initialized = true;
    this.log("Initialized");

    if (window.name != '') {
      this.controller.load(window.name);
    }
  },

  log: function(message) {
    this.console.logStringMessage("FoxGo: " + message);
  }
};
