function InfoView(model, frame, gameMenu) {
  var document = frame.contentDocument;
  var root = document.documentElement;

  var head = root.getElementsByTagName("head").item(0);
  var style = document.createElement("link");

  style.setAttribute("rel", "stylesheet");
  style.setAttribute("type", "text/css");
  style.setAttribute("href", "chrome://foxgo/skin/foxgo-info.css");

  head.appendChild(style);

  var body = root.getElementsByTagName("body").item(0);
  var table = document.createElement("table");

  body.appendChild(table);

  function clear() {
    var children = table.childNodes;
    var length = children.length;

    for (var i = length - 1; i >= 0; i--) {
      table.removeChild(children.item(i));
    }
  }

  function textToTd(str, class) {
    var td = document.createElement("td");
    var span = document.createElement("span");
    var text = document.createTextNode(str);

    td.appendChild(span);
    span.appendChild(text);

    span.setAttribute("class", class);

    return td;
  }

  function appendField(field, value) {
    var tr = document.createElement("tr");

    tr.appendChild(textToTd(field, "foxgo-info-field"));
    tr.appendChild(textToTd(value, "foxgo-info-value"));

    table.appendChild(tr);
  }

  function tryAppendField(field, propName) {
    var val = model.getProperty(propName);

    if (val != undefined) {
      appendField(field, val);
    }
  }

  function appendPlayerInfo(colour) {
    var value = "";
    var player = model.getProperty("P" + colour);
    var rank = model.getProperty(colour + "R");

    if (player != undefined) {
      value += player;
    }

    if ((rank != undefined) && (value != "")) {
      value += ", " + rank;
    } else if (rank != undefined) {
      value = rank;
    } else {
      return;
    }

    if (colour == "B") {
      appendField("Black:", value);
    } else {
      appendField("White:", value);
    }
  }

  function populateGameMenu() {
    var doc = gameMenu.ownerDocument;
    var children = gameMenu.childNodes;
    var length = children.length;

    gameMenu.removeAllItems();

    var gamelist = model.getGameNames();

    for (var i = 0; i < gamelist.length; i++) {
      var item = gameMenu.insertItemAt(i, (i + 1) + ". " + gamelist[i], gamelist[i], "");
    }

    gameMenu.selectedIndex = 0;

    if (gamelist.length == 1) {
      gameMenu.setAttribute("disabled", "true");
    } else if (gameMenu.hasAttribute("disabled")) {
      gameMenu.removeAttribute("disabled");
    }
  }

  this.refreshGameMenu = function() {
    populateGameMenu()
  }

  this.refresh = function() {
    clear();

    tryAppendField("Event:", "EV");
    tryAppendField("Round:", "RO");
    tryAppendField("Date:", "DT");
    tryAppendField("Location:", "PC");
    appendPlayerInfo("B");
    appendPlayerInfo("W");
    tryAppendField("Komi:", "KM");
    tryAppendField("Result:", "RE");
  }
}
